import java.util.*;
import javax.swing.*;
import javax.swing.table.*;

public class JDBCControlPanel extends javax.swing.JFrame {
  private JDBCConnect dbConnection;
  
  /** Creates new form JDBCControlPanel */
  public JDBCControlPanel() {
    dbConnection = new JDBCConnect();
    dbConnection.setParentFrame(this);
    initComponents();
    toggleODBC();
    toggleValidateProject();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
    tabbedPane = new javax.swing.JTabbedPane();
    driverPanel = new javax.swing.JPanel();
    driverInputPanel = new javax.swing.JPanel();
    nameLabel = new javax.swing.JLabel();
    nameField = new javax.swing.JTextField();
    urlLabel = new javax.swing.JLabel();
    urlField = new javax.swing.JTextField();
    dbLabel = new javax.swing.JLabel();
    dbField = new javax.swing.JTextField();
    tableLabel = new javax.swing.JLabel();
    tableField = new javax.swing.JTextField();
    odbcCheckBox = new javax.swing.JCheckBox();
    driverButtonPanel = new javax.swing.JPanel();
    driverOK = new javax.swing.JButton();
    driverCancel = new javax.swing.JButton();
    driverTest = new javax.swing.JButton();
    fieldPanel = new javax.swing.JPanel();
    fieldScrollPane = new javax.swing.JScrollPane();
    fieldMapping = new javax.swing.JTable();
    fieldButtonPanel = new javax.swing.JPanel();
    fieldOK = new javax.swing.JButton();
    fieldCancel = new javax.swing.JButton();
    fieldRefresh = new javax.swing.JButton();
    optionPanel = new javax.swing.JPanel();
    optionInputPanel = new javax.swing.JPanel();
    hourLabel = new javax.swing.JLabel();
    hourComboBox = new javax.swing.JComboBox();
    projectCaseCheckBox = new javax.swing.JCheckBox();
    projValidateCheckBox = new javax.swing.JCheckBox();
    projDBLabel = new javax.swing.JLabel();
    projDBField = new javax.swing.JTextField();
    projTableLabel = new javax.swing.JLabel();
    projTableField = new javax.swing.JTextField();
    projFieldLabel = new javax.swing.JLabel();
    projFieldComboBox = new javax.swing.JComboBox();
    optionButtonPanel = new javax.swing.JPanel();
    optionOK = new javax.swing.JButton();
    optionCancel = new javax.swing.JButton();
    optionApply = new javax.swing.JButton();
    
    getContentPane().setLayout(new java.awt.GridLayout(1, 1));
    
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        exitForm(evt);
      }
    });
    
    tabbedPane.setPreferredSize(new java.awt.Dimension(387, 254));
    driverPanel.setLayout(new java.awt.BorderLayout());
    
    driverPanel.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentShown(java.awt.event.ComponentEvent evt) {
        showDriverPanel(evt);
      }
    });
    
    driverInputPanel.setLayout(new java.awt.GridBagLayout());
    java.awt.GridBagConstraints gridBagConstraints1;
    
    nameLabel.setText("Driver Name");
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    driverInputPanel.add(nameLabel, gridBagConstraints1);
    
    nameField.setColumns(20);
    nameField.setText(dbConnection.name);
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    driverInputPanel.add(nameField, gridBagConstraints1);
    
    urlLabel.setText("URL");
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    driverInputPanel.add(urlLabel, gridBagConstraints1);
    
    urlField.setText(dbConnection.url);
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    driverInputPanel.add(urlField, gridBagConstraints1);
    
    dbLabel.setText("Database");
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    driverInputPanel.add(dbLabel, gridBagConstraints1);
    
    dbField.setText(dbConnection.database);
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    driverInputPanel.add(dbField, gridBagConstraints1);
    
    tableLabel.setText("Table");
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    driverInputPanel.add(tableLabel, gridBagConstraints1);
    
    tableField.setText(dbConnection.table);
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    driverInputPanel.add(tableField, gridBagConstraints1);
    
    odbcCheckBox.setSelected(dbConnection.name.equals(JDBCConnect.odbcDriverName));
    odbcCheckBox.setForeground(new java.awt.Color(102, 102, 153));
    odbcCheckBox.setText("Use ODBC Bridge");
    odbcCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        toggleODBC(evt);
      }
    });
    
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    driverInputPanel.add(odbcCheckBox, gridBagConstraints1);
    
    driverPanel.add(driverInputPanel, java.awt.BorderLayout.CENTER);
    
    driverOK.setText("OK");
    driverOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        saveDriverSettings(evt);
      }
    });
    
    driverButtonPanel.add(driverOK);
    
    driverCancel.setText("Cancel");
    driverCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cancel(evt);
      }
    });
    
    driverButtonPanel.add(driverCancel);
    
    driverTest.setText("Test");
    driverTest.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        testDriverSettings(evt);
      }
    });
    
    driverButtonPanel.add(driverTest);
    
    driverPanel.add(driverButtonPanel, java.awt.BorderLayout.SOUTH);
    
    tabbedPane.addTab("Driver Settings", driverPanel);
    
    fieldPanel.setLayout(new java.awt.BorderLayout());
    
    fieldPanel.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentShown(java.awt.event.ComponentEvent evt) {
        showFieldMap(evt);
      }
    });
    
    fieldMapping.setModel(dbConnection.tableMap.toTableModel());
    fieldScrollPane.setViewportView(fieldMapping);
    
    fieldPanel.add(fieldScrollPane, java.awt.BorderLayout.CENTER);
    
    fieldOK.setText("OK");
    fieldOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        saveDriverSettings(evt);
      }
    });
    
    fieldButtonPanel.add(fieldOK);
    
    fieldCancel.setText("Cancel");
    fieldCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cancel(evt);
      }
    });
    
    fieldButtonPanel.add(fieldCancel);
    
    fieldRefresh.setText("Refresh");
    fieldRefresh.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        refreshFieldMap(evt);
      }
    });
    
    fieldButtonPanel.add(fieldRefresh);
    
    fieldPanel.add(fieldButtonPanel, java.awt.BorderLayout.SOUTH);
    
    tabbedPane.addTab("Field Mappings", fieldPanel);
    
    optionPanel.setLayout(new java.awt.BorderLayout());
    
    optionPanel.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentShown(java.awt.event.ComponentEvent evt) {
        showOptionPanel(evt);
      }
    });
    
    optionInputPanel.setLayout(new java.awt.GridBagLayout());
    java.awt.GridBagConstraints gridBagConstraints2;
    
    hourLabel.setText("Export hours by:");
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
    optionInputPanel.add(hourLabel, gridBagConstraints2);
    
    hourComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Full Precision", "Quarter of an hour", "Tenth of an hour" }));
    hourComboBox.setSelectedIndex(dbConnection.hourFormat);
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
    optionInputPanel.add(hourComboBox, gridBagConstraints2);
    
    projectCaseCheckBox.setSelected(dbConnection.projectCase);
    projectCaseCheckBox.setForeground(new java.awt.Color(102, 102, 153));
    projectCaseCheckBox.setText("Upper-Case Project");
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
    optionInputPanel.add(projectCaseCheckBox, gridBagConstraints2);
    
    projValidateCheckBox.setSelected(dbConnection.projectValidate);
    projValidateCheckBox.setForeground(new java.awt.Color(102, 102, 153));
    projValidateCheckBox.setText("Validate Project");
    projValidateCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        toggleValidateProject(evt);
      }
    });
    
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
    optionInputPanel.add(projValidateCheckBox, gridBagConstraints2);
    
    projDBLabel.setText("Project Database:");
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
    optionInputPanel.add(projDBLabel, gridBagConstraints2);
    
    projDBField.setText(dbConnection.projectDatabase);
    projDBField.setEnabled(false);
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
    optionInputPanel.add(projDBField, gridBagConstraints2);
    
    projTableLabel.setText("Project Table:");
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
    optionInputPanel.add(projTableLabel, gridBagConstraints2);
    
    projTableField.setText(dbConnection.projectTable);
    projTableField.setEnabled(false);
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
    optionInputPanel.add(projTableField, gridBagConstraints2);
    
    projFieldLabel.setText("Project Field");
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
    optionInputPanel.add(projFieldLabel, gridBagConstraints2);
    
    projFieldComboBox.setModel(new DefaultComboBoxModel(new String[] {dbConnection.projectField}));
    projFieldComboBox.setEnabled(false);
    gridBagConstraints2 = new java.awt.GridBagConstraints();
    gridBagConstraints2.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
    optionInputPanel.add(projFieldComboBox, gridBagConstraints2);
    
    optionPanel.add(optionInputPanel, java.awt.BorderLayout.CENTER);
    
    optionOK.setText("OK");
    optionOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        saveDriverSettings(evt);
      }
    });
    
    optionButtonPanel.add(optionOK);
    
    optionCancel.setText("Cancel");
    optionCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cancel(evt);
      }
    });
    
    optionButtonPanel.add(optionCancel);
    
    optionApply.setText("Refresh");
    optionApply.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        applyOptions(evt);
      }
    });
    
    optionButtonPanel.add(optionApply);
    
    optionPanel.add(optionButtonPanel, java.awt.BorderLayout.SOUTH);
    
    tabbedPane.addTab("Options", optionPanel);
    
    getContentPane().add(tabbedPane);
    
    pack();
  }//GEN-END:initComponents
  
  private void applyOptions(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_applyOptions
    dbConnection.projectDatabase = projDBField.getText();
    dbConnection.projectTable = projTableField.getText();
    int projFieldIndex = projFieldComboBox.getSelectedIndex();
    dbConnection.projectField = (String)projFieldComboBox.getItemAt(projFieldIndex);
    String[] fieldNames = dbConnection.getProjectFieldNames();
    DefaultComboBoxModel boxModel;
    if(fieldNames == null) {
      boxModel = new DefaultComboBoxModel(new String[] {"No Fields Found"});
      projFieldComboBox.setEnabled(false);
    } else {
      boxModel = new DefaultComboBoxModel(fieldNames);
      projFieldComboBox.setEnabled(true);
    }
    projFieldComboBox.setModel(boxModel);
    optionInputPanel.repaint();
  }//GEN-LAST:event_applyOptions
  
  private void toggleValidateProject(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toggleValidateProject
    toggleValidateProject();
  }//GEN-LAST:event_toggleValidateProject
  
  private void toggleValidateProject() {
    if(projValidateCheckBox.isSelected()) {
      projDBField.enable();
      projTableField.enable();
    } else {
      projDBField.disable();
      projTableField.disable();
    }
    optionInputPanel.repaint();
  }
  
  private void showDriverPanel(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_showDriverPanel
    getRootPane().setDefaultButton(driverOK);
  }//GEN-LAST:event_showDriverPanel
  
  private void showOptionPanel(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_showOptionPanel
    getRootPane().setDefaultButton(optionOK);
  }//GEN-LAST:event_showOptionPanel
  
  private void toggleODBC(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toggleODBC
    toggleODBC();
  }//GEN-LAST:event_toggleODBC
  private void toggleODBC() {
    if(odbcCheckBox.isSelected()) {
      nameField.setText(JDBCConnect.odbcDriverName);
      nameField.disable();
      urlLabel.setText("Data Source");
      int lastColon = dbConnection.url.lastIndexOf(':')+1;
      urlField.setText(dbConnection.url.substring(lastColon));
    } else {
      nameField.setText(dbConnection.name);
      nameField.enable();
      urlLabel.setText("URL");
      urlField.setText(dbConnection.url);
    }
    driverInputPanel.repaint();
  }
  private void refreshFieldMap(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshFieldMap
    try {
      dbConnection.tableMap.init();
      fieldMapping.setModel(dbConnection.tableMap.toTableModel());
      fieldMapping.repaint();
    } catch (java.sql.SQLException e) {
      System.err.println("Couldn't initialize table mapping");
    }
  }//GEN-LAST:event_refreshFieldMap
  
  private void showFieldMap(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_showFieldMap
    getRootPane().setDefaultButton(fieldOK);
    if(dbConnection.tableMap.size() == 0) {
      try {
        dbConnection.tableMap.init();
        fieldMapping.setModel(dbConnection.tableMap.toTableModel());
        fieldMapping.repaint();
      } catch (java.sql.SQLException e) {
        System.err.println("Couldn't initialize table mapping");
      }
    }
  }//GEN-LAST:event_showFieldMap
  
  private void testDriverSettings(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_testDriverSettings
    String name = nameField.getText();
    String url = urlField.getText();
    String database = dbField.getText();
    String table = tableField.getText();
    JDBCConnect testConnection = new JDBCConnect(name, url, database, table);
    testConnection.testDriverSettings();
  }//GEN-LAST:event_testDriverSettings
  
  private void cancel(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancel
    exitForm();
  }//GEN-LAST:event_cancel
  
  private void saveDriverSettings(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveDriverSettings
    dbConnection.name = nameField.getText();
    dbConnection.url = urlField.getText();
    if(dbConnection.name.equals(JDBCConnect.odbcDriverName)) 
      dbConnection.url = "jdbc:odbc:"+dbConnection.url;
    dbConnection.database = dbField.getText();
    dbConnection.table = tableField.getText();
    dbConnection.projectDatabase = projDBField.getText();
    dbConnection.projectTable = projTableField.getText();
    if(projFieldComboBox.getItemCount() != 0) {
      int projFieldIndex = projFieldComboBox.getSelectedIndex();
      dbConnection.projectField = (String)projFieldComboBox.getItemAt(projFieldIndex);
    }
    dbConnection.projectValidate = projValidateCheckBox.isSelected();
    dbConnection.hourFormat = hourComboBox.getSelectedIndex();
    dbConnection.projectCase = projectCaseCheckBox.isSelected();
    for(int i=0; i < dbConnection.tableMap.size(); i++) {
      String value = (String)fieldMapping.getValueAt(i, 2);
      JDBCConnect.FieldMap record = (JDBCConnect.FieldMap)dbConnection.tableMap.elementAt(i);
      record.valueExpression = value;
    }
    dbConnection.savePrefs();
    exitForm();
  }//GEN-LAST:event_saveDriverSettings
        private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
          exitForm();
    }//GEN-LAST:event_exitForm
    
    private void exitForm() {
      setVisible(false);
      dispose();
    }
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane tabbedPane;
    private javax.swing.JPanel driverPanel;
    private javax.swing.JPanel driverInputPanel;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JTextField nameField;
    private javax.swing.JLabel urlLabel;
    private javax.swing.JTextField urlField;
    private javax.swing.JLabel dbLabel;
    private javax.swing.JTextField dbField;
    private javax.swing.JLabel tableLabel;
    private javax.swing.JTextField tableField;
    private javax.swing.JCheckBox odbcCheckBox;
    private javax.swing.JPanel driverButtonPanel;
    private javax.swing.JButton driverOK;
    private javax.swing.JButton driverCancel;
    private javax.swing.JButton driverTest;
    private javax.swing.JPanel fieldPanel;
    private javax.swing.JScrollPane fieldScrollPane;
    private javax.swing.JTable fieldMapping;
    private javax.swing.JPanel fieldButtonPanel;
    private javax.swing.JButton fieldOK;
    private javax.swing.JButton fieldCancel;
    private javax.swing.JButton fieldRefresh;
    private javax.swing.JPanel optionPanel;
    private javax.swing.JPanel optionInputPanel;
    private javax.swing.JLabel hourLabel;
    private javax.swing.JComboBox hourComboBox;
    private javax.swing.JCheckBox projectCaseCheckBox;
    private javax.swing.JCheckBox projValidateCheckBox;
    private javax.swing.JLabel projDBLabel;
    private javax.swing.JTextField projDBField;
    private javax.swing.JLabel projTableLabel;
    private javax.swing.JTextField projTableField;
    private javax.swing.JLabel projFieldLabel;
    private javax.swing.JComboBox projFieldComboBox;
    private javax.swing.JPanel optionButtonPanel;
    private javax.swing.JButton optionOK;
    private javax.swing.JButton optionCancel;
    private javax.swing.JButton optionApply;
    // End of variables declaration//GEN-END:variables
}
