//Swing Components
import javax.swing.*;
import javax.swing.event.*;

/*
 * ProjectEditDialog.java
 * Created on January 8, 2002, 1:30 PM
 * @author John T. Ellis
 */
public class ProjectEditDialog extends javax.swing.JDialog {
  final TimeRecord record;
  private String value;
  private int attributes;
  
  public ProjectEditDialog(JFrame frame, TimeRecord timerec, int attrib) {
    super(frame, true);
    record = timerec;
    attributes = attrib;
    initComponents();
    billable.setVisible(attributeSet(ClntComm.SHOW_BILLABLE));
    export.setVisible(attributeSet(ClntComm.SHOW_EXPORT));
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
    inputPanel = new javax.swing.JPanel();
    projLabel = new javax.swing.JLabel();
    projField = new javax.swing.JTextField();
    aliasLabel = new javax.swing.JLabel();
    aliasField = new javax.swing.JTextField();
    timeLabel = new javax.swing.JLabel();
    timeField = new javax.swing.JTextField();
    billable = new javax.swing.JCheckBox();
    export = new javax.swing.JCheckBox();
    buttonPanel = new javax.swing.JPanel();
    okButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();
    
    setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
    setTitle("Edit Project");
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        closeDialog(evt);
      }
    });
    
    inputPanel.setLayout(new java.awt.GridBagLayout());
    java.awt.GridBagConstraints gridBagConstraints1;
    
    projLabel.setText("Project: ");
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    inputPanel.add(projLabel, gridBagConstraints1);
    
    projField.setColumns(15);
    projField.setText(record.projectName);
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
    inputPanel.add(projField, gridBagConstraints1);
    
    aliasLabel.setText("Alias: ");
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    inputPanel.add(aliasLabel, gridBagConstraints1);
    
    aliasField.setColumns(15);
    aliasField.setText(record.alias);
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
    inputPanel.add(aliasField, gridBagConstraints1);
    
    timeLabel.setText("Time: ");
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    inputPanel.add(timeLabel, gridBagConstraints1);
    
    timeField.setColumns(10);
    timeField.setText(record.toMinuteString());
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
    inputPanel.add(timeField, gridBagConstraints1);
    
    billable.setForeground(new java.awt.Color(102, 102, 153));
    billable.setSelected(record.billable);
    billable.setText("Billable Project");
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
    inputPanel.add(billable, gridBagConstraints1);
    
    export.setForeground(new java.awt.Color(102, 102, 153));
    export.setSelected(record.export);
    export.setText("Export Project to Database");
    gridBagConstraints1 = new java.awt.GridBagConstraints();
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
    inputPanel.add(export, gridBagConstraints1);
    
    getContentPane().add(inputPanel, java.awt.BorderLayout.CENTER);
    
    getRootPane().setDefaultButton(okButton);
    okButton.setText("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        save(evt);
      }
    });
    
    buttonPanel.add(okButton);
    
    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cancel(evt);
      }
    });
    
    buttonPanel.add(cancelButton);
    
    getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);
    
    pack();
  }//GEN-END:initComponents
  
  private void save(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_save
    record.projectName = projField.getText();
    record.setSeconds(timeField.getText());
    if(aliasField.getText().length() > 0) record.alias = aliasField.getText();
    else record.alias = null;
    record.billable = billable.isSelected();
    record.export = export.isSelected();
    value = "0";
    closeDialog();
  }//GEN-LAST:event_save
  
  private void cancel(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancel
    value = "1";
    closeDialog();
  }//GEN-LAST:event_cancel
  
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
      closeDialog();
    }//GEN-LAST:event_closeDialog
    
    private void closeDialog() {
      setVisible(false);
      dispose();
    }
    
    public String getValue() {
      return value;
    }
    
    public boolean attributeSet(int flag) {
      return flag==0 ? true : (flag ^ attributes) != (flag | attributes);
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel inputPanel;
    private javax.swing.JLabel projLabel;
    private javax.swing.JTextField projField;
    private javax.swing.JLabel aliasLabel;
    private javax.swing.JTextField aliasField;
    private javax.swing.JLabel timeLabel;
    private javax.swing.JTextField timeField;
    private javax.swing.JCheckBox billable;
    private javax.swing.JCheckBox export;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton okButton;
    private javax.swing.JButton cancelButton;
    // End of variables declaration//GEN-END:variables
    
}
